var page;
var chipfamily;
var latest_sys_version = 1.16;
const urlparams = window.location.search;
const urlparsed = new URLSearchParams(urlparams);
var hidden = true;
var conn_counter = 0;
var conn_test = true;
var conn_active = false;
var conn_data = false;
var conn_auth = false;
var but_menu = false;
var but_conn = false;
var ip;
var inputip = document.getElementById("inputip");
var statusdot = document.getElementById("statusdot");
var statusdot2 = document.getElementById("statusdot2");
var activeprod = document.getElementById("activeprod");
var activename = document.getElementById("activename");
var activeuptime = document.getElementById("activeuptime");
var activeserial = document.getElementById("activeserial");
var activemac = document.getElementById("activemac");
var main_menu_but =  document.getElementById("main_menu");
var main_conn_but =  document.getElementById("main_conn");
var page_side_r =  document.getElementById("page_side_r");
var page_side_l =  document.getElementById("page_side_l");
var opt_disp = false;
const inputs = document.querySelectorAll('input,select');
var opt_sreg = false;
var opt_rgb = false;
var opt_rgb2 = false;
var opt_audio = false;
var gpio = new Array();
var sys_procs;
var sys_version;
var sys_licence;
var sys_prefix;
var sys_compatible;
var mapping=["N/A","N/A","N/A","N/A","N/A"];
var procname=["N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A","N/A"];

var lastinputindex=inputs.length-1;

function removeallchanges() {inputs.forEach(function(inputs,k) {inputs.classList.remove("chng");});}
function inputchange(inputs,k) {if(k==lastinputindex) return;
                                inputs.addEventListener("input", function(){addchange(this.id);});}
if(page!="backup" && page!="system" && page!="debug") {inputs.forEach(inputchange);}
function addchange(id) {document.getElementById(id).classList.add("chng");}

function resetesp() {
   if(!conn_active){
          alert("ERROR: Connection missing! Please, check connection to the device!");
          return;
          }
   var ssv = new XMLHttpRequest();
   var url = "http:\\\\"+ip+"\\execute?command=reboot";
   ssv.open("POST", url, true);
   ssv.setRequestHeader('Content-type', 'text/plain');
   ssv.withCredentials = conn_auth;
   if(confirm("Reboot device?")) ssv.send("");
}

function factoryreset() {
   if(!conn_active){
          alert("ERROR: Connection missing! Please, check connection to the device!");
          return;
          }
   var ssv = new XMLHttpRequest();
   var url = "http:\\\\"+ip+"\\execute?command=factory";
   ssv.open("POST", url, true);
   ssv.setRequestHeader('Content-type', 'text/plain');
   ssv.withCredentials = conn_auth;
   if(confirm("Reset device to factory settings?")) ssv.send("");
}

function resetwifi() {
   if(!conn_active){
          alert("ERROR: Connection missing! Please, check connection to the device!");
          return;
          }
   var ssv = new XMLHttpRequest();
   var url = "http:\\\\"+ip+"\\execute?command=reconnect";
   ssv.open("POST", url, true);
   ssv.setRequestHeader('Content-type', 'text/plain');
   ssv.withCredentials = conn_auth;
   if(confirm("Reconnect to WiFi and MQTT?")) ssv.send("");
}

function batch_save() {
   if(!conn_active){
          alert("ERROR: Connection missing! Please, check connection to the device!");
          return;
          }
   if(!conn_data){
          alert("ERROR: Page outdated, please refresh!");
          return;
          }
   var url = "http:\\\\"+ip+"\\settings_import?mode="+page;
   var ssv = new XMLHttpRequest();
   	ssv.open("POST", url, true);
   	ssv.setRequestHeader('Content-type', 'text/plain');
	  ssv.withCredentials = conn_auth;
   	ssv.send(exportstring_save());
   	ssv.onreadystatechange = function() {
      		if (this.readyState == 4 && this.status == 200) {
          if (this.responseText == checkstring()){
        			removeallchanges();
              handshake();
        			} else {
        			alert("Save failed, try again!");
              alert(this.responseText);
              alert(checkstring());
        			}
      		}
   };
}


function batch_load() {
  if (typeof page !== 'undefined') {
     var url = "http:\\\\"+ip+"\\settings_export?mode="+page;
     var eepr = new XMLHttpRequest();
            eepr.open("GET", url, true);
            eepr.setRequestHeader('Content-type', 'text/plain');
            eepr.withCredentials = conn_auth;
  	        eepr.send();
            eepr.onreadystatechange = function() {
                if (this.readyState == 4 && this.status == 200) {
                  conn_data=true;
                  jsontext=this.responseText;
  		            exportstring_load();
                  }
                };
  }
}

function handshake() {
    activeip.innerHTML="";
    activemac.innerHTML="";
    activeprod.innerHTML="";
    activeuptime.innerHTML="";
    activename.innerHTML="";
    activeserial.innerHTML="";
    statusdot.classList.remove("doton");
    statusdot.classList.remove("dotoff");
    statusdot2.classList.remove("doton");
    statusdot2.classList.remove("dotoff");
   var url = "http:\\\\"+ip+"\\handshake";
   var eepr = new XMLHttpRequest();
          eepr.open("GET", url, true);
          eepr.setRequestHeader('Content-type', 'text/plain');
	        eepr.send();
          eepr.onreadystatechange = function() {
              if (this.readyState == 4 && this.status == 200) {
                const resp=JSON.parse(this.responseText);
                if(resp.chipfamily==undefined){chipfamily="ESP8266"} else {chipfamily = resp.chipfamily;}
                setglobals(chipfamily);
                if(resp.procs==undefined){
                    sys_prefix="";
                    sys_compatible = false;
                    alert("No compatible device found on "+ip+"!");
                    return;
                  }
            		activeip.innerHTML=ip;
            		activemac.innerHTML=resp.mac;
            		activeprod.innerHTML=resp.prod;
            		activeuptime.innerHTML=resp.uptime;
            		activename.innerHTML=resp.name;
            		activeserial.innerHTML=resp.serial;
                if(chipfamily=="ESP8266") {
                    for (let i = 0; i <= 8; i++) {
                      gpio[i]=eval("resp.d"+i);
                    }
                  }
                else {
                    for (let i = 0; i <= 50; i++) {
                      if(!validGPIO[i]) continue;
                      gpio[i]=eval("resp.io"+i);
                    }
                  }

                sys_procs=resp.procs;
                sys_version=resp.version;
                sys_licence=resp.license;
                if(sys_procs==undefined) sys_procs=25;
                if(sys_version==undefined) sys_version=0.96;
                opt_rgb=resp.opt_rgb;
                if(sys_version==undefined) opt_rgb=false;
                opt_rgb2=resp.opt_rgb2;
                if(opt_rgb2==undefined) opt_rgb2=false;
                opt_audio=resp.opt_audio;
                if(opt_audio==undefined) opt_audio=false;
                opt_disp=resp.opt_disp;
                conn_auth=resp.auth;
                if(document.getElementById("lic_mac")!=null){
                    document.getElementById("lic_mac").value=resp.mac;
                    document.getElementById("lic_prod").value=resp.prod;
                    document.getElementById("lic_mac2").innerHTML=resp.mac;
                    document.getElementById("lic_prod2").innerHTML=resp.prod;
                    }
                if(resp.prod=="105-UCON-FREE") {
                      document.getElementById("lic_button").classList.add("red");
                  } else {
                      document.getElementById("lic_button").classList.remove("red");
                      if(document.getElementById("lic_mac")!=null){
                          page_activated();
                          }
                  }
                for(i=0;  i<5; i++){mapping[i]=eval("resp.mapname_"+(i+1));}
                for(i=0; i<40; i++){procname[i]=eval("resp.p"+(i+1));}

                procname[0]=resp.p1;

                opt_sreg=!!+resp.opt_sreg==1;
            		statusdot.classList.add("doton");
                statusdot2.classList.add("doton");
            		localStorage.setItem("lastip", ip);
                document.cookie = "unicontrollastip="+ip+"; max-age=" + 180*24*60*60 + "; path=/; SameSite=Lax";
                console.log("Saving current session's IP: "+ip);
                conn_active = true;
                if(document.getElementById("update_popup")!=null && resp.version*1 < 1.03) document.getElementById("update_popup").classList.remove("hidden");
                contentfilter();
            		batch_load();
                data_load();
                }
              };
}

function ping_timeout() {
   if(!conn_test) {
     conn_counter++;
     statusdot.classList.remove("doton");
     statusdot2.classList.remove("doton");
     if(conn_counter>5){
        statusdot.classList.add("dotoff");
        statusdot.classList.remove("dotina");
        statusdot2.classList.add("dotoff");
        statusdot2.classList.remove("dotina");
        activeip.innerHTML="";
        activemac.innerHTML="";
        activeprod.innerHTML="";
        activeuptime.innerHTML="";
        activename.innerHTML="";
        activeserial.innerHTML="";
        statusdot.classList.remove("doton");
        statusdot.classList.remove("dotoff");
        statusdot2.classList.remove("doton");
        statusdot2.classList.remove("dotoff");
        conn_active=false;
        conn_data=false;
        flush();
      } else {
        statusdot.classList.add("dotina");
        statusdot.classList.remove("dotoff");
        statusdot2.classList.add("dotina");
        statusdot2.classList.remove("dotoff");
        conn_active=false;
      }
   }
   if(conn_test) {
    if(conn_counter>5){
       handshake();
       conn_active=true;
     } else {
        statusdot.classList.remove("dotina");
        statusdot.classList.add("doton");
        statusdot2.classList.remove("dotina");
        statusdot2.classList.add("doton");
        conn_active=true;
     }
    conn_counter=0;
   }
}

function ping_test() {
   conn_test = false;
   var url = "http:\\\\"+ip+"\\ping";
   setTimeout(ping_timeout, 1000);
   var eepr = new XMLHttpRequest();
          eepr.open("GET", url, true);
          eepr.setRequestHeader('Content-type', 'text/plain');
	        eepr.send();
          eepr.onreadystatechange = function() {
              if (this.readyState == 4 && this.status == 200) {
                conn_test=true;
                }
              };
}

function connect() {
   ip = inputip.value;
   handshake();
}

function container_hide(no){
    var curr_state = document.getElementById('mark'+no).innerHTML;
    var container = document.getElementById('cont'+no);
    if (curr_state == "-"){
        document.getElementById('mark'+no).innerHTML="+";
        container.classList.add("hidden");
      } else {
        document.getElementById('mark'+no).innerHTML="-";
        container.classList.remove("hidden");
      }
    }


function showexp(){
      if(hidden){
        hidden=false;
        exportimport.classList.remove("hidden");
      } else {
        hidden=true;
        exportimport.classList.add("hidden");
      }
    }

document.getElementById('fader').classList.remove("fader");

var ping_test = setInterval(ping_test, 2000);

function show_menu(){
    if(but_menu){
      but_menu = false;
      but_conn = false;
      page_side_l.classList.remove('show');
      page_side_r.classList.remove('show');
    } else {
      but_menu = true;
      but_conn = false;
      page_side_l.classList.add('show');
      page_side_r.classList.remove('show');
    }
}

function show_conn(){
    if(but_conn){
      but_conn = false;
      but_menu = false;
      page_side_r.classList.remove('show');
      page_side_l.classList.remove('show');
    } else {
      but_conn = true;
      but_menu = false;
      page_side_r.classList.add('show');
      page_side_l.classList.remove('show');
    }
}

function hide_all(){
  but_conn = false;
  but_menu = false;
  page_side_r.classList.remove('show');
  page_side_l.classList.remove('show');
}

document.addEventListener("click", hide_all, false);
page_side_r.addEventListener("click", function (ev) {ev.stopPropagation();}, false);
page_side_l.addEventListener("click", function (ev) {ev.stopPropagation();}, false);
main_menu_but.addEventListener("click", function (ev) {ev.stopPropagation();}, false);
main_conn_but.addEventListener("click", function (ev) {ev.stopPropagation();}, false);


function activation() {
   var url = './license.htm';                   // vygeneruje plnú URL
   window.location.href = url;
}

if(urlparsed.get('connect') != null) {
    ip = urlparsed.get('connect');
    console.log("Fetching IP from URL: "+ip);
    }
else{
    const cookies = document.cookie.split("; ");
    let cookie_ip = null;

    for (let i = 0; i < cookies.length; i++) {
        const [name, value] = cookies[i].split("=");
        if (name === "unicontrollastip") {
            cookie_ip = value;
            break;
            }
        }
    if(cookie_ip != null){
        ip = cookie_ip;
        console.log("Fetching IP from cookie: "+ip);
        }
    else if(localStorage.getItem("lastip")!=null){
        ip=localStorage.getItem("lastip");
        console.log("Fetching IP from previous session: "+ip);
      }
    else{
        ip="192.168.1.1";
        console.log("No IP available, using default IP: 192.168.1.1");
        }
    }
inputip.value=ip;
handshake();
