var page = "device";
var jsontext;
var devicename = document.getElementById("devicename");
var masterpass = document.getElementById("masterpass");
var prod = document.getElementById("prod");
var serialno = document.getElementById("serialno");
var firmware = document.getElementById("firmware");
var firmware2;
var kernel;
var mac = document.getElementById("mac");
var devtime = document.getElementById("devtime");
var timezone = document.getElementById("timezone");
var serial = document.getElementById("serial");
var secure = document.getElementById("secure");
var origin = document.getElementById("origin");
var dst = document.getElementById("dst");
var display = document.getElementById("display");

function checkstring(){
     var string_106="";
     var string_114="";
     if(sys_version >= 1.06) string_106 = ",\"dst\":"+dst.value + ",\"display\":"+display.value;
     if(sys_version >= 1.14) string_114 = ",\"unit\":"+unit.value;
     var exportstring = "{\"devicename\":\""+devicename.value
                         +"\",\"secure\":"+secure.value
                         +",\"origin\":\""+origin.value
			                   +"\",\"timezone\":"+timezone.value
                         + string_106
                         + string_114
                         +",\"serial\":"+serial.value
                         +"}"
	return exportstring;
    }

function exportstring_save(){
     var string_106="";
     var string_114="";
     if(sys_version >= 1.06) string_106 = ",\"dst\":"+dst.value + ",\"display\":"+display.value;
     if(sys_version >= 1.14) string_114 = ",\"unit\":"+unit.value;
     var exportstring = "{\"devicename\":\""+devicename.value
			                   +"\",\"secure\":"+secure.value
                         +",\"origin\":\""+origin.value
                         +"\",\"timezone\":"+timezone.value
                         + string_106
                         + string_114
			                   +",\"serial\":"+serial.value
                         +",\"masterpass\":\""+masterpass.value
                         +"\"}";
	return exportstring;
    }


function exportstring_load(){
      const load = JSON.parse(jsontext);
      devicename.value = load.devicename;
      prod.value = load.prod;
      serialno.value = load.serialno;
      firmware.value = load.firmware;
      firmware2 = load.firmware2;
      kernel = load.kernel;
      mac.value = load.mac;
      devtime.value = load.devtime;
      timezone.value = load.timezone;
      serial.value = load.serial;
      origin.value = load.origin;
      secure.value = load.secure;
      if(sys_version >= 1.06) dst.value = load.dst;
      if(sys_version >= 1.06) display.value = load.display;
      if(sys_version >= 1.14) unit.value = load.unit;

      document.getElementById('fader').classList.remove("fader");
    }


function contentfilter(){
    if(sys_version < 1.06){
      document.getElementById('dst_row').classList.add("hidden");
      document.getElementById('display_row').classList.add("hidden");
      } else {
      document.getElementById('dst_row').classList.remove("hidden");
      document.getElementById('display_row').classList.remove("hidden");
      }
    if(sys_version < 1.14){
      document.getElementById('unit_row').classList.add("hidden");
      for (let i = 2; i <= 5; i++){document.getElementById('dst_'+i).classList.add("hidden");}
      } else {
      document.getElementById('unit_row').classList.remove("hidden");
      for (let i = 2; i <= 5; i++){document.getElementById('dst_'+i).classList.remove("hidden");}
      }
    }

function data_load() {}

function flush(){
      devicename.value = "";
      masterpass.value = "";
      prod.value = "";
      serialno.value = "";
      firmware.value = "";
      mac.value = "";
      devtime.value = "";
      timezone.value = "";
      origin.value = "";
      secure.value = 0;
      dst.value = 99;
      display.value = 0;
      unit.value = 99;
      serial.value = 99;
}
