var page = "rgb";
var rgbmod1 = document.getElementById("rgbmod1");
var rgbcolor1 = document.getElementById("rgbcolor1");
var rgbbrt1 = document.getElementById("rgbbrt1");
var rgbspd1 = document.getElementById("rgbspd1");
var redpin1 = document.getElementById("redpin1");
var greenpin1 = document.getElementById("greenpin1");
var bluepin1 = document.getElementById("bluepin1");
var whitepin1 = document.getElementById("whitepin1");
var rgbmod2 = document.getElementById("rgbmod2");
var rgbcolor2 = document.getElementById("rgbcolor2");
var rgbbrt2 = document.getElementById("rgbbrt2");
var rgbspd2 = document.getElementById("rgbspd2");
var redpin2 = document.getElementById("redpin2");
var greenpin2 = document.getElementById("greenpin2");
var bluepin2 = document.getElementById("bluepin2");
var whitepin2 = document.getElementById("whitepin2");
var jsontext;

function contentfilter(){
    if(sys_version<1.081){
        document.getElementById('rgb_page').classList.add("hidden");
        document.getElementById('unavailable').classList.remove("hidden");
    } else {
        document.getElementById('rgb_page').classList.remove("hidden");
        document.getElementById('unavailable').classList.add("hidden");
    }
}

function flush(){
      rgbmod1.value = 0;
      rgbcolor1.value = "#000000";
      rgbbrt1.value = 100;
      rgbspd1.value = 100;
      rgbmod2.value = 0;
      rgbcolor2.value = "#000000";
      rgbbrt2.value = 100;
      rgbspd2.value = 100;
      redpin1.innerHTML = "";
      greenpin1.innerHTML = "";
      bluepin1.innerHTML = "";
      whitepin1.innerHTML = "";
      redpin2.innerHTML = "";
      greenpin2.innerHTML = "";
      bluepin2.innerHTML = "";
      whitepin2.innerHTML = "";
      document.title = "RGB module - Edit";
    }

function checkstring() {
   return exportstring_save();
}

function load_textarea() {
      jsontext = jsontextarea.value;
      exportstring_load();
}

function exportstring_load(){
      flush();
      const load = JSON.parse(jsontext);
      if(sys_version<1.14){
         rgbmod1.value = load.rgbmod;
         rgbcolor1.value = load.rgbcolor;
         rgbbrt1.value = load.rgbbrt;
         rgbspd1.value = load.rgbspd;
         redpin1.innerHTML = load.redpin;
         greenpin1.innerHTML = load.greenpin;
         bluepin1.innerHTML = load.bluepin;
         whitepin1.innerHTML = load.whitepin;
      } else {
         rgbmod1.value = load.rgbmod1;
         rgbcolor1.value = load.rgbcolor1;
         rgbbrt1.value = load.rgbbrt1;
         rgbspd1.value = load.rgbspd1;
         redpin1.innerHTML = load.redpin1;
         greenpin1.innerHTML = load.greenpin1;
         bluepin1.innerHTML = load.bluepin1;
         whitepin1.innerHTML = load.whitepin1;
         rgbmod2.value = load.rgbmod2;
         rgbcolor2.value = load.rgbcolor2;
         rgbbrt2.value = load.rgbbrt2;
         rgbspd2.value = load.rgbspd2;
         redpin2.innerHTML = load.redpin2;
         greenpin2.innerHTML = load.greenpin2;
         bluepin2.innerHTML = load.bluepin2;
         whitepin2.innerHTML = load.whitepin2;
       }
      contentfilter();
      removeallchanges();
    }

function exportstring_save() {
  if(sys_version<1.14){
   jsontext = "{\"rgbmod\":" + rgbmod1.value;
   jsontext += ",\"rgbcolor\":\"" + rgbcolor1.value;
   jsontext += "\",\"rgbspd\":" + rgbspd1.value;
   jsontext += ",\"rgbbrt\":" + rgbbrt1.value;
   jsontext += "}";
} else {
   jsontext = "{\"rgbmod1\":" + rgbmod1.value;
   jsontext += ",\"rgbmod2\":" + rgbmod2.value;
   jsontext += ",\"rgbcolor1\":\"" + rgbcolor1.value;
   jsontext += "\",\"rgbcolor2\":\"" + rgbcolor2.value;
   jsontext += "\",\"rgbspd1\":" + rgbspd1.value;
   jsontext += ",\"rgbspd2\":" + rgbspd2.value;
   jsontext += ",\"rgbbrt1\":" + rgbbrt1.value;
   jsontext += ",\"rgbbrt2\":" + rgbbrt2.value;
   jsontext += "}";
 }
   return jsontext;
   alert(jsontext);
}

function data_load() {topics();}

function topics() {
   var eepr = new XMLHttpRequest();
   var url = "http:\\\\"+ip+"\\proc_topics?proc_id=1";
          eepr.open("GET", url, true);
          eepr.setRequestHeader('Content-type', 'text/plain');
          eepr.withCredentials = conn_auth;
	  eepr.send();
          eepr.onreadystatechange = function() {
              if (this.readyState == 4 && this.status == 200) {
                const load = JSON.parse(this.responseText);
                if(sys_version<1.14){
                   document.getElementById("rgbmod1_topic").innerHTML=load.root+"/sub/rgbmod";
                   document.getElementById("rgbcolor1_topic").innerHTML=load.root+"/sub/rgbcolor";
                   document.getElementById("rgbspd1_topic").innerHTML=load.root+"/sub/rgbspd";
                   document.getElementById("rgbbrt1_topic").innerHTML=load.root+"/sub/rgbbrt";
                } else {
                   document.getElementById("rgbmod1_topic").innerHTML=load.root+"/sub/rgbmod1";
                   document.getElementById("rgbcolor1_topic").innerHTML=load.root+"/sub/rgbcolor1";
                   document.getElementById("rgbspd1_topic").innerHTML=load.root+"/sub/rgbspd1";
                   document.getElementById("rgbbrt1_topic").innerHTML=load.root+"/sub/rgbbrt1";
                   document.getElementById("rgbmod2_topic").innerHTML=load.root+"/sub/rgbmod2";
                   document.getElementById("rgbcolor2_topic").innerHTML=load.root+"/sub/rgbcolor2";
                   document.getElementById("rgbspd2_topic").innerHTML=load.root+"/sub/rgbspd2";
                   document.getElementById("rgbbrt2_topic").innerHTML=load.root+"/sub/rgbbrt2";
                 }
                }
              };
}

contentfilter();
